// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include "args.hxx"

// eingabe_t
// 

const eingabe_t::config_type& eingabe_t::
config () const
{
  return this->config_.get ();
}

eingabe_t::config_type& eingabe_t::
config ()
{
  return this->config_.get ();
}

void eingabe_t::
config (const config_type& x)
{
  this->config_.set (x);
}

void eingabe_t::
config (::std::unique_ptr< config_type > x)
{
  this->config_.set (std::move (x));
}

const eingabe_t::extra_thermostat_optional& eingabe_t::
extra_thermostat () const
{
  return this->extra_thermostat_;
}

eingabe_t::extra_thermostat_optional& eingabe_t::
extra_thermostat ()
{
  return this->extra_thermostat_;
}

void eingabe_t::
extra_thermostat (const extra_thermostat_type& x)
{
  this->extra_thermostat_.set (x);
}

void eingabe_t::
extra_thermostat (const extra_thermostat_optional& x)
{
  this->extra_thermostat_ = x;
}

void eingabe_t::
extra_thermostat (::std::unique_ptr< extra_thermostat_type > x)
{
  this->extra_thermostat_.set (std::move (x));
}

const eingabe_t::extra_linked_cell_optional& eingabe_t::
extra_linked_cell () const
{
  return this->extra_linked_cell_;
}

eingabe_t::extra_linked_cell_optional& eingabe_t::
extra_linked_cell ()
{
  return this->extra_linked_cell_;
}

void eingabe_t::
extra_linked_cell (const extra_linked_cell_type& x)
{
  this->extra_linked_cell_.set (x);
}

void eingabe_t::
extra_linked_cell (const extra_linked_cell_optional& x)
{
  this->extra_linked_cell_ = x;
}

void eingabe_t::
extra_linked_cell (::std::unique_ptr< extra_linked_cell_type > x)
{
  this->extra_linked_cell_.set (std::move (x));
}


// config
// 

const config::out_enabled_type& config::
out_enabled () const
{
  return this->out_enabled_.get ();
}

config::out_enabled_type& config::
out_enabled ()
{
  return this->out_enabled_.get ();
}

void config::
out_enabled (const out_enabled_type& x)
{
  this->out_enabled_.set (x);
}

const config::output_basename_type& config::
output_basename () const
{
  return this->output_basename_.get ();
}

config::output_basename_type& config::
output_basename ()
{
  return this->output_basename_.get ();
}

void config::
output_basename (const output_basename_type& x)
{
  this->output_basename_.set (x);
}

void config::
output_basename (::std::unique_ptr< output_basename_type > x)
{
  this->output_basename_.set (std::move (x));
}

const config::vis_enabled_type& config::
vis_enabled () const
{
  return this->vis_enabled_.get ();
}

config::vis_enabled_type& config::
vis_enabled ()
{
  return this->vis_enabled_.get ();
}

void config::
vis_enabled (const vis_enabled_type& x)
{
  this->vis_enabled_.set (x);
}

const config::vis_color_range_min_type& config::
vis_color_range_min () const
{
  return this->vis_color_range_min_.get ();
}

config::vis_color_range_min_type& config::
vis_color_range_min ()
{
  return this->vis_color_range_min_.get ();
}

void config::
vis_color_range_min (const vis_color_range_min_type& x)
{
  this->vis_color_range_min_.set (x);
}

const config::vis_color_range_max_type& config::
vis_color_range_max () const
{
  return this->vis_color_range_max_.get ();
}

config::vis_color_range_max_type& config::
vis_color_range_max ()
{
  return this->vis_color_range_max_.get ();
}

void config::
vis_color_range_max (const vis_color_range_max_type& x)
{
  this->vis_color_range_max_.set (x);
}

const config::output_frequency_type& config::
output_frequency () const
{
  return this->output_frequency_.get ();
}

config::output_frequency_type& config::
output_frequency ()
{
  return this->output_frequency_.get ();
}

void config::
output_frequency (const output_frequency_type& x)
{
  this->output_frequency_.set (x);
}

const config::t_end_type& config::
t_end () const
{
  return this->t_end_.get ();
}

config::t_end_type& config::
t_end ()
{
  return this->t_end_.get ();
}

void config::
t_end (const t_end_type& x)
{
  this->t_end_.set (x);
}

const config::delta_t_type& config::
delta_t () const
{
  return this->delta_t_.get ();
}

config::delta_t_type& config::
delta_t ()
{
  return this->delta_t_.get ();
}

void config::
delta_t (const delta_t_type& x)
{
  this->delta_t_.set (x);
}

const config::calculator_name_type& config::
calculator_name () const
{
  return this->calculator_name_.get ();
}

config::calculator_name_type& config::
calculator_name ()
{
  return this->calculator_name_.get ();
}

void config::
calculator_name (const calculator_name_type& x)
{
  this->calculator_name_.set (x);
}

void config::
calculator_name (::std::unique_ptr< calculator_name_type > x)
{
  this->calculator_name_.set (std::move (x));
}

const config::eingabefile_type& config::
eingabefile () const
{
  return this->eingabefile_.get ();
}

config::eingabefile_type& config::
eingabefile ()
{
  return this->eingabefile_.get ();
}

void config::
eingabefile (const eingabefile_type& x)
{
  this->eingabefile_.set (x);
}

void config::
eingabefile (::std::unique_ptr< eingabefile_type > x)
{
  this->eingabefile_.set (std::move (x));
}

const config::thermostat_enabled_type& config::
thermostat_enabled () const
{
  return this->thermostat_enabled_.get ();
}

config::thermostat_enabled_type& config::
thermostat_enabled ()
{
  return this->thermostat_enabled_.get ();
}

void config::
thermostat_enabled (const thermostat_enabled_type& x)
{
  this->thermostat_enabled_.set (x);
}

const config::gravity_enabled_type& config::
gravity_enabled () const
{
  return this->gravity_enabled_.get ();
}

config::gravity_enabled_type& config::
gravity_enabled ()
{
  return this->gravity_enabled_.get ();
}

void config::
gravity_enabled (const gravity_enabled_type& x)
{
  this->gravity_enabled_.set (x);
}

const config::gravity_constant_type& config::
gravity_constant () const
{
  return this->gravity_constant_.get ();
}

config::gravity_constant_type& config::
gravity_constant ()
{
  return this->gravity_constant_.get ();
}

void config::
gravity_constant (const gravity_constant_type& x)
{
  this->gravity_constant_.set (x);
}

const config::gravity_axis_type& config::
gravity_axis () const
{
  return this->gravity_axis_.get ();
}

config::gravity_axis_type& config::
gravity_axis ()
{
  return this->gravity_axis_.get ();
}

void config::
gravity_axis (const gravity_axis_type& x)
{
  this->gravity_axis_.set (x);
}

void config::
gravity_axis (::std::unique_ptr< gravity_axis_type > x)
{
  this->gravity_axis_.set (std::move (x));
}

const config::algorithm_type& config::
algorithm () const
{
  return this->algorithm_.get ();
}

config::algorithm_type& config::
algorithm ()
{
  return this->algorithm_.get ();
}

void config::
algorithm (const algorithm_type& x)
{
  this->algorithm_.set (x);
}

void config::
algorithm (::std::unique_ptr< algorithm_type > x)
{
  this->algorithm_.set (std::move (x));
}

const config::import_simulation_data_type& config::
import_simulation_data () const
{
  return this->import_simulation_data_.get ();
}

config::import_simulation_data_type& config::
import_simulation_data ()
{
  return this->import_simulation_data_.get ();
}

void config::
import_simulation_data (const import_simulation_data_type& x)
{
  this->import_simulation_data_.set (x);
}

const config::export_simulation_data_type& config::
export_simulation_data () const
{
  return this->export_simulation_data_.get ();
}

config::export_simulation_data_type& config::
export_simulation_data ()
{
  return this->export_simulation_data_.get ();
}

void config::
export_simulation_data (const export_simulation_data_type& x)
{
  this->export_simulation_data_.set (x);
}

const config::import_export_fileURI_type& config::
import_export_fileURI () const
{
  return this->import_export_fileURI_.get ();
}

config::import_export_fileURI_type& config::
import_export_fileURI ()
{
  return this->import_export_fileURI_.get ();
}

void config::
import_export_fileURI (const import_export_fileURI_type& x)
{
  this->import_export_fileURI_.set (x);
}

void config::
import_export_fileURI (::std::unique_ptr< import_export_fileURI_type > x)
{
  this->import_export_fileURI_.set (std::move (x));
}

const config::membrane_enabled_type& config::
membrane_enabled () const
{
  return this->membrane_enabled_.get ();
}

config::membrane_enabled_type& config::
membrane_enabled ()
{
  return this->membrane_enabled_.get ();
}

void config::
membrane_enabled (const membrane_enabled_type& x)
{
  this->membrane_enabled_.set (x);
}

const config::fz_up_type& config::
fz_up () const
{
  return this->fz_up_.get ();
}

config::fz_up_type& config::
fz_up ()
{
  return this->fz_up_.get ();
}

void config::
fz_up (const fz_up_type& x)
{
  this->fz_up_.set (x);
}

const config::k_type& config::
k () const
{
  return this->k_.get ();
}

config::k_type& config::
k ()
{
  return this->k_.get ();
}

void config::
k (const k_type& x)
{
  this->k_.set (x);
}

const config::r_0_type& config::
r_0 () const
{
  return this->r_0_.get ();
}

config::r_0_type& config::
r_0 ()
{
  return this->r_0_.get ();
}

void config::
r_0 (const r_0_type& x)
{
  this->r_0_.set (x);
}

const config::x_length_type& config::
x_length () const
{
  return this->x_length_.get ();
}

config::x_length_type& config::
x_length ()
{
  return this->x_length_.get ();
}

void config::
x_length (const x_length_type& x)
{
  this->x_length_.set (x);
}


// extra_thermostat
// 

const extra_thermostat::temp_init_type& extra_thermostat::
temp_init () const
{
  return this->temp_init_.get ();
}

extra_thermostat::temp_init_type& extra_thermostat::
temp_init ()
{
  return this->temp_init_.get ();
}

void extra_thermostat::
temp_init (const temp_init_type& x)
{
  this->temp_init_.set (x);
}

const extra_thermostat::n_thermostat_type& extra_thermostat::
n_thermostat () const
{
  return this->n_thermostat_.get ();
}

extra_thermostat::n_thermostat_type& extra_thermostat::
n_thermostat ()
{
  return this->n_thermostat_.get ();
}

void extra_thermostat::
n_thermostat (const n_thermostat_type& x)
{
  this->n_thermostat_.set (x);
}

const extra_thermostat::needs_init_type& extra_thermostat::
needs_init () const
{
  return this->needs_init_.get ();
}

extra_thermostat::needs_init_type& extra_thermostat::
needs_init ()
{
  return this->needs_init_.get ();
}

void extra_thermostat::
needs_init (const needs_init_type& x)
{
  this->needs_init_.set (x);
}

const extra_thermostat::num_dim_of_sim_type& extra_thermostat::
num_dim_of_sim () const
{
  return this->num_dim_of_sim_.get ();
}

extra_thermostat::num_dim_of_sim_type& extra_thermostat::
num_dim_of_sim ()
{
  return this->num_dim_of_sim_.get ();
}

void extra_thermostat::
num_dim_of_sim (const num_dim_of_sim_type& x)
{
  this->num_dim_of_sim_.set (x);
}

const extra_thermostat::temp_target_optional& extra_thermostat::
temp_target () const
{
  return this->temp_target_;
}

extra_thermostat::temp_target_optional& extra_thermostat::
temp_target ()
{
  return this->temp_target_;
}

void extra_thermostat::
temp_target (const temp_target_type& x)
{
  this->temp_target_.set (x);
}

void extra_thermostat::
temp_target (const temp_target_optional& x)
{
  this->temp_target_ = x;
}

const extra_thermostat::gradual_type& extra_thermostat::
gradual () const
{
  return this->gradual_.get ();
}

extra_thermostat::gradual_type& extra_thermostat::
gradual ()
{
  return this->gradual_.get ();
}

void extra_thermostat::
gradual (const gradual_type& x)
{
  this->gradual_.set (x);
}

const extra_thermostat::temp_delta_optional& extra_thermostat::
temp_delta () const
{
  return this->temp_delta_;
}

extra_thermostat::temp_delta_optional& extra_thermostat::
temp_delta ()
{
  return this->temp_delta_;
}

void extra_thermostat::
temp_delta (const temp_delta_type& x)
{
  this->temp_delta_.set (x);
}

void extra_thermostat::
temp_delta (const temp_delta_optional& x)
{
  this->temp_delta_ = x;
}


// extra_linked_cell
// 

const extra_linked_cell::center_x_type& extra_linked_cell::
center_x () const
{
  return this->center_x_.get ();
}

extra_linked_cell::center_x_type& extra_linked_cell::
center_x ()
{
  return this->center_x_.get ();
}

void extra_linked_cell::
center_x (const center_x_type& x)
{
  this->center_x_.set (x);
}

const extra_linked_cell::center_y_type& extra_linked_cell::
center_y () const
{
  return this->center_y_.get ();
}

extra_linked_cell::center_y_type& extra_linked_cell::
center_y ()
{
  return this->center_y_.get ();
}

void extra_linked_cell::
center_y (const center_y_type& x)
{
  this->center_y_.set (x);
}

const extra_linked_cell::center_z_type& extra_linked_cell::
center_z () const
{
  return this->center_z_.get ();
}

extra_linked_cell::center_z_type& extra_linked_cell::
center_z ()
{
  return this->center_z_.get ();
}

void extra_linked_cell::
center_z (const center_z_type& x)
{
  this->center_z_.set (x);
}

const extra_linked_cell::domain_x_type& extra_linked_cell::
domain_x () const
{
  return this->domain_x_.get ();
}

extra_linked_cell::domain_x_type& extra_linked_cell::
domain_x ()
{
  return this->domain_x_.get ();
}

void extra_linked_cell::
domain_x (const domain_x_type& x)
{
  this->domain_x_.set (x);
}

const extra_linked_cell::domain_y_type& extra_linked_cell::
domain_y () const
{
  return this->domain_y_.get ();
}

extra_linked_cell::domain_y_type& extra_linked_cell::
domain_y ()
{
  return this->domain_y_.get ();
}

void extra_linked_cell::
domain_y (const domain_y_type& x)
{
  this->domain_y_.set (x);
}

const extra_linked_cell::domain_z_type& extra_linked_cell::
domain_z () const
{
  return this->domain_z_.get ();
}

extra_linked_cell::domain_z_type& extra_linked_cell::
domain_z ()
{
  return this->domain_z_.get ();
}

void extra_linked_cell::
domain_z (const domain_z_type& x)
{
  this->domain_z_.set (x);
}

const extra_linked_cell::cutoffradius_type& extra_linked_cell::
cutoffradius () const
{
  return this->cutoffradius_.get ();
}

extra_linked_cell::cutoffradius_type& extra_linked_cell::
cutoffradius ()
{
  return this->cutoffradius_.get ();
}

void extra_linked_cell::
cutoffradius (const cutoffradius_type& x)
{
  this->cutoffradius_.set (x);
}

const extra_linked_cell::left_bound_cond_type& extra_linked_cell::
left_bound_cond () const
{
  return this->left_bound_cond_.get ();
}

extra_linked_cell::left_bound_cond_type& extra_linked_cell::
left_bound_cond ()
{
  return this->left_bound_cond_.get ();
}

void extra_linked_cell::
left_bound_cond (const left_bound_cond_type& x)
{
  this->left_bound_cond_.set (x);
}

void extra_linked_cell::
left_bound_cond (::std::unique_ptr< left_bound_cond_type > x)
{
  this->left_bound_cond_.set (std::move (x));
}

const extra_linked_cell::right_bound_cond_type& extra_linked_cell::
right_bound_cond () const
{
  return this->right_bound_cond_.get ();
}

extra_linked_cell::right_bound_cond_type& extra_linked_cell::
right_bound_cond ()
{
  return this->right_bound_cond_.get ();
}

void extra_linked_cell::
right_bound_cond (const right_bound_cond_type& x)
{
  this->right_bound_cond_.set (x);
}

void extra_linked_cell::
right_bound_cond (::std::unique_ptr< right_bound_cond_type > x)
{
  this->right_bound_cond_.set (std::move (x));
}

const extra_linked_cell::down_bound_cond_type& extra_linked_cell::
down_bound_cond () const
{
  return this->down_bound_cond_.get ();
}

extra_linked_cell::down_bound_cond_type& extra_linked_cell::
down_bound_cond ()
{
  return this->down_bound_cond_.get ();
}

void extra_linked_cell::
down_bound_cond (const down_bound_cond_type& x)
{
  this->down_bound_cond_.set (x);
}

void extra_linked_cell::
down_bound_cond (::std::unique_ptr< down_bound_cond_type > x)
{
  this->down_bound_cond_.set (std::move (x));
}

const extra_linked_cell::up_bound_cond_type& extra_linked_cell::
up_bound_cond () const
{
  return this->up_bound_cond_.get ();
}

extra_linked_cell::up_bound_cond_type& extra_linked_cell::
up_bound_cond ()
{
  return this->up_bound_cond_.get ();
}

void extra_linked_cell::
up_bound_cond (const up_bound_cond_type& x)
{
  this->up_bound_cond_.set (x);
}

void extra_linked_cell::
up_bound_cond (::std::unique_ptr< up_bound_cond_type > x)
{
  this->up_bound_cond_.set (std::move (x));
}

const extra_linked_cell::front_bound_cond_type& extra_linked_cell::
front_bound_cond () const
{
  return this->front_bound_cond_.get ();
}

extra_linked_cell::front_bound_cond_type& extra_linked_cell::
front_bound_cond ()
{
  return this->front_bound_cond_.get ();
}

void extra_linked_cell::
front_bound_cond (const front_bound_cond_type& x)
{
  this->front_bound_cond_.set (x);
}

void extra_linked_cell::
front_bound_cond (::std::unique_ptr< front_bound_cond_type > x)
{
  this->front_bound_cond_.set (std::move (x));
}

const extra_linked_cell::back_bound_cond_type& extra_linked_cell::
back_bound_cond () const
{
  return this->back_bound_cond_.get ();
}

extra_linked_cell::back_bound_cond_type& extra_linked_cell::
back_bound_cond ()
{
  return this->back_bound_cond_.get ();
}

void extra_linked_cell::
back_bound_cond (const back_bound_cond_type& x)
{
  this->back_bound_cond_.set (x);
}

void extra_linked_cell::
back_bound_cond (::std::unique_ptr< back_bound_cond_type > x)
{
  this->back_bound_cond_.set (std::move (x));
}


#include <xsd/cxx/xml/dom/parsing-source.hxx>

// eingabe_t
//

eingabe_t::
eingabe_t (const config_type& config)
: ::xml_schema::type (),
  config_ (config, this),
  extra_thermostat_ (this),
  extra_linked_cell_ (this)
{
}

eingabe_t::
eingabe_t (::std::unique_ptr< config_type > config)
: ::xml_schema::type (),
  config_ (std::move (config), this),
  extra_thermostat_ (this),
  extra_linked_cell_ (this)
{
}

eingabe_t::
eingabe_t (const eingabe_t& x,
           ::xml_schema::flags f,
           ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  config_ (x.config_, f, this),
  extra_thermostat_ (x.extra_thermostat_, f, this),
  extra_linked_cell_ (x.extra_linked_cell_, f, this)
{
}

eingabe_t::
eingabe_t (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f,
           ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  config_ (this),
  extra_thermostat_ (this),
  extra_linked_cell_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void eingabe_t::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // config
    //
    if (n.name () == "config" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< config_type > r (
        config_traits::create (i, f, this));

      if (!config_.present ())
      {
        this->config_.set (::std::move (r));
        continue;
      }
    }

    // extra_thermostat
    //
    if (n.name () == "extra_thermostat" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< extra_thermostat_type > r (
        extra_thermostat_traits::create (i, f, this));

      if (!this->extra_thermostat_)
      {
        this->extra_thermostat_.set (::std::move (r));
        continue;
      }
    }

    // extra_linked_cell
    //
    if (n.name () == "extra_linked_cell" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< extra_linked_cell_type > r (
        extra_linked_cell_traits::create (i, f, this));

      if (!this->extra_linked_cell_)
      {
        this->extra_linked_cell_.set (::std::move (r));
        continue;
      }
    }

    break;
  }

  if (!config_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "config",
      "");
  }
}

eingabe_t* eingabe_t::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class eingabe_t (*this, f, c);
}

eingabe_t& eingabe_t::
operator= (const eingabe_t& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->config_ = x.config_;
    this->extra_thermostat_ = x.extra_thermostat_;
    this->extra_linked_cell_ = x.extra_linked_cell_;
  }

  return *this;
}

eingabe_t::
~eingabe_t ()
{
}

// config
//

config::
config (const out_enabled_type& out_enabled,
        const output_basename_type& output_basename,
        const vis_enabled_type& vis_enabled,
        const vis_color_range_min_type& vis_color_range_min,
        const vis_color_range_max_type& vis_color_range_max,
        const output_frequency_type& output_frequency,
        const t_end_type& t_end,
        const delta_t_type& delta_t,
        const calculator_name_type& calculator_name,
        const eingabefile_type& eingabefile,
        const thermostat_enabled_type& thermostat_enabled,
        const gravity_enabled_type& gravity_enabled,
        const gravity_constant_type& gravity_constant,
        const gravity_axis_type& gravity_axis,
        const algorithm_type& algorithm,
        const import_simulation_data_type& import_simulation_data,
        const export_simulation_data_type& export_simulation_data,
        const import_export_fileURI_type& import_export_fileURI,
        const membrane_enabled_type& membrane_enabled,
        const fz_up_type& fz_up,
        const k_type& k,
        const r_0_type& r_0,
        const x_length_type& x_length)
: ::xml_schema::type (),
  out_enabled_ (out_enabled, this),
  output_basename_ (output_basename, this),
  vis_enabled_ (vis_enabled, this),
  vis_color_range_min_ (vis_color_range_min, this),
  vis_color_range_max_ (vis_color_range_max, this),
  output_frequency_ (output_frequency, this),
  t_end_ (t_end, this),
  delta_t_ (delta_t, this),
  calculator_name_ (calculator_name, this),
  eingabefile_ (eingabefile, this),
  thermostat_enabled_ (thermostat_enabled, this),
  gravity_enabled_ (gravity_enabled, this),
  gravity_constant_ (gravity_constant, this),
  gravity_axis_ (gravity_axis, this),
  algorithm_ (algorithm, this),
  import_simulation_data_ (import_simulation_data, this),
  export_simulation_data_ (export_simulation_data, this),
  import_export_fileURI_ (import_export_fileURI, this),
  membrane_enabled_ (membrane_enabled, this),
  fz_up_ (fz_up, this),
  k_ (k, this),
  r_0_ (r_0, this),
  x_length_ (x_length, this)
{
}

config::
config (const config& x,
        ::xml_schema::flags f,
        ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  out_enabled_ (x.out_enabled_, f, this),
  output_basename_ (x.output_basename_, f, this),
  vis_enabled_ (x.vis_enabled_, f, this),
  vis_color_range_min_ (x.vis_color_range_min_, f, this),
  vis_color_range_max_ (x.vis_color_range_max_, f, this),
  output_frequency_ (x.output_frequency_, f, this),
  t_end_ (x.t_end_, f, this),
  delta_t_ (x.delta_t_, f, this),
  calculator_name_ (x.calculator_name_, f, this),
  eingabefile_ (x.eingabefile_, f, this),
  thermostat_enabled_ (x.thermostat_enabled_, f, this),
  gravity_enabled_ (x.gravity_enabled_, f, this),
  gravity_constant_ (x.gravity_constant_, f, this),
  gravity_axis_ (x.gravity_axis_, f, this),
  algorithm_ (x.algorithm_, f, this),
  import_simulation_data_ (x.import_simulation_data_, f, this),
  export_simulation_data_ (x.export_simulation_data_, f, this),
  import_export_fileURI_ (x.import_export_fileURI_, f, this),
  membrane_enabled_ (x.membrane_enabled_, f, this),
  fz_up_ (x.fz_up_, f, this),
  k_ (x.k_, f, this),
  r_0_ (x.r_0_, f, this),
  x_length_ (x.x_length_, f, this)
{
}

config::
config (const ::xercesc::DOMElement& e,
        ::xml_schema::flags f,
        ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  out_enabled_ (this),
  output_basename_ (this),
  vis_enabled_ (this),
  vis_color_range_min_ (this),
  vis_color_range_max_ (this),
  output_frequency_ (this),
  t_end_ (this),
  delta_t_ (this),
  calculator_name_ (this),
  eingabefile_ (this),
  thermostat_enabled_ (this),
  gravity_enabled_ (this),
  gravity_constant_ (this),
  gravity_axis_ (this),
  algorithm_ (this),
  import_simulation_data_ (this),
  export_simulation_data_ (this),
  import_export_fileURI_ (this),
  membrane_enabled_ (this),
  fz_up_ (this),
  k_ (this),
  r_0_ (this),
  x_length_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void config::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // out_enabled
    //
    if (n.name () == "out_enabled" && n.namespace_ ().empty ())
    {
      if (!out_enabled_.present ())
      {
        this->out_enabled_.set (out_enabled_traits::create (i, f, this));
        continue;
      }
    }

    // output_basename
    //
    if (n.name () == "output_basename" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< output_basename_type > r (
        output_basename_traits::create (i, f, this));

      if (!output_basename_.present ())
      {
        this->output_basename_.set (::std::move (r));
        continue;
      }
    }

    // vis_enabled
    //
    if (n.name () == "vis_enabled" && n.namespace_ ().empty ())
    {
      if (!vis_enabled_.present ())
      {
        this->vis_enabled_.set (vis_enabled_traits::create (i, f, this));
        continue;
      }
    }

    // vis_color_range_min
    //
    if (n.name () == "vis_color_range_min" && n.namespace_ ().empty ())
    {
      if (!vis_color_range_min_.present ())
      {
        this->vis_color_range_min_.set (vis_color_range_min_traits::create (i, f, this));
        continue;
      }
    }

    // vis_color_range_max
    //
    if (n.name () == "vis_color_range_max" && n.namespace_ ().empty ())
    {
      if (!vis_color_range_max_.present ())
      {
        this->vis_color_range_max_.set (vis_color_range_max_traits::create (i, f, this));
        continue;
      }
    }

    // output_frequency
    //
    if (n.name () == "output_frequency" && n.namespace_ ().empty ())
    {
      if (!output_frequency_.present ())
      {
        this->output_frequency_.set (output_frequency_traits::create (i, f, this));
        continue;
      }
    }

    // t_end
    //
    if (n.name () == "t_end" && n.namespace_ ().empty ())
    {
      if (!t_end_.present ())
      {
        this->t_end_.set (t_end_traits::create (i, f, this));
        continue;
      }
    }

    // delta_t
    //
    if (n.name () == "delta_t" && n.namespace_ ().empty ())
    {
      if (!delta_t_.present ())
      {
        this->delta_t_.set (delta_t_traits::create (i, f, this));
        continue;
      }
    }

    // calculator_name
    //
    if (n.name () == "calculator_name" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< calculator_name_type > r (
        calculator_name_traits::create (i, f, this));

      if (!calculator_name_.present ())
      {
        this->calculator_name_.set (::std::move (r));
        continue;
      }
    }

    // eingabefile
    //
    if (n.name () == "eingabefile" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< eingabefile_type > r (
        eingabefile_traits::create (i, f, this));

      if (!eingabefile_.present ())
      {
        this->eingabefile_.set (::std::move (r));
        continue;
      }
    }

    // thermostat_enabled
    //
    if (n.name () == "thermostat_enabled" && n.namespace_ ().empty ())
    {
      if (!thermostat_enabled_.present ())
      {
        this->thermostat_enabled_.set (thermostat_enabled_traits::create (i, f, this));
        continue;
      }
    }

    // gravity_enabled
    //
    if (n.name () == "gravity_enabled" && n.namespace_ ().empty ())
    {
      if (!gravity_enabled_.present ())
      {
        this->gravity_enabled_.set (gravity_enabled_traits::create (i, f, this));
        continue;
      }
    }

    // gravity_constant
    //
    if (n.name () == "gravity_constant" && n.namespace_ ().empty ())
    {
      if (!gravity_constant_.present ())
      {
        this->gravity_constant_.set (gravity_constant_traits::create (i, f, this));
        continue;
      }
    }

    // gravity_axis
    //
    if (n.name () == "gravity_axis" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< gravity_axis_type > r (
        gravity_axis_traits::create (i, f, this));

      if (!gravity_axis_.present ())
      {
        this->gravity_axis_.set (::std::move (r));
        continue;
      }
    }

    // algorithm
    //
    if (n.name () == "algorithm" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< algorithm_type > r (
        algorithm_traits::create (i, f, this));

      if (!algorithm_.present ())
      {
        this->algorithm_.set (::std::move (r));
        continue;
      }
    }

    // import_simulation_data
    //
    if (n.name () == "import_simulation_data" && n.namespace_ ().empty ())
    {
      if (!import_simulation_data_.present ())
      {
        this->import_simulation_data_.set (import_simulation_data_traits::create (i, f, this));
        continue;
      }
    }

    // export_simulation_data
    //
    if (n.name () == "export_simulation_data" && n.namespace_ ().empty ())
    {
      if (!export_simulation_data_.present ())
      {
        this->export_simulation_data_.set (export_simulation_data_traits::create (i, f, this));
        continue;
      }
    }

    // import_export_fileURI
    //
    if (n.name () == "import_export_fileURI" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< import_export_fileURI_type > r (
        import_export_fileURI_traits::create (i, f, this));

      if (!import_export_fileURI_.present ())
      {
        this->import_export_fileURI_.set (::std::move (r));
        continue;
      }
    }

    // membrane_enabled
    //
    if (n.name () == "membrane_enabled" && n.namespace_ ().empty ())
    {
      if (!membrane_enabled_.present ())
      {
        this->membrane_enabled_.set (membrane_enabled_traits::create (i, f, this));
        continue;
      }
    }

    // fz_up
    //
    if (n.name () == "fz_up" && n.namespace_ ().empty ())
    {
      if (!fz_up_.present ())
      {
        this->fz_up_.set (fz_up_traits::create (i, f, this));
        continue;
      }
    }

    // k
    //
    if (n.name () == "k" && n.namespace_ ().empty ())
    {
      if (!k_.present ())
      {
        this->k_.set (k_traits::create (i, f, this));
        continue;
      }
    }

    // r_0
    //
    if (n.name () == "r_0" && n.namespace_ ().empty ())
    {
      if (!r_0_.present ())
      {
        this->r_0_.set (r_0_traits::create (i, f, this));
        continue;
      }
    }

    // x_length
    //
    if (n.name () == "x_length" && n.namespace_ ().empty ())
    {
      if (!x_length_.present ())
      {
        this->x_length_.set (x_length_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!out_enabled_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "out_enabled",
      "");
  }

  if (!output_basename_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "output_basename",
      "");
  }

  if (!vis_enabled_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "vis_enabled",
      "");
  }

  if (!vis_color_range_min_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "vis_color_range_min",
      "");
  }

  if (!vis_color_range_max_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "vis_color_range_max",
      "");
  }

  if (!output_frequency_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "output_frequency",
      "");
  }

  if (!t_end_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "t_end",
      "");
  }

  if (!delta_t_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "delta_t",
      "");
  }

  if (!calculator_name_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "calculator_name",
      "");
  }

  if (!eingabefile_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "eingabefile",
      "");
  }

  if (!thermostat_enabled_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "thermostat_enabled",
      "");
  }

  if (!gravity_enabled_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "gravity_enabled",
      "");
  }

  if (!gravity_constant_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "gravity_constant",
      "");
  }

  if (!gravity_axis_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "gravity_axis",
      "");
  }

  if (!algorithm_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "algorithm",
      "");
  }

  if (!import_simulation_data_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "import_simulation_data",
      "");
  }

  if (!export_simulation_data_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "export_simulation_data",
      "");
  }

  if (!import_export_fileURI_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "import_export_fileURI",
      "");
  }

  if (!membrane_enabled_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "membrane_enabled",
      "");
  }

  if (!fz_up_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "fz_up",
      "");
  }

  if (!k_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "k",
      "");
  }

  if (!r_0_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "r_0",
      "");
  }

  if (!x_length_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "x_length",
      "");
  }
}

config* config::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class config (*this, f, c);
}

config& config::
operator= (const config& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->out_enabled_ = x.out_enabled_;
    this->output_basename_ = x.output_basename_;
    this->vis_enabled_ = x.vis_enabled_;
    this->vis_color_range_min_ = x.vis_color_range_min_;
    this->vis_color_range_max_ = x.vis_color_range_max_;
    this->output_frequency_ = x.output_frequency_;
    this->t_end_ = x.t_end_;
    this->delta_t_ = x.delta_t_;
    this->calculator_name_ = x.calculator_name_;
    this->eingabefile_ = x.eingabefile_;
    this->thermostat_enabled_ = x.thermostat_enabled_;
    this->gravity_enabled_ = x.gravity_enabled_;
    this->gravity_constant_ = x.gravity_constant_;
    this->gravity_axis_ = x.gravity_axis_;
    this->algorithm_ = x.algorithm_;
    this->import_simulation_data_ = x.import_simulation_data_;
    this->export_simulation_data_ = x.export_simulation_data_;
    this->import_export_fileURI_ = x.import_export_fileURI_;
    this->membrane_enabled_ = x.membrane_enabled_;
    this->fz_up_ = x.fz_up_;
    this->k_ = x.k_;
    this->r_0_ = x.r_0_;
    this->x_length_ = x.x_length_;
  }

  return *this;
}

config::
~config ()
{
}

// extra_thermostat
//

extra_thermostat::
extra_thermostat (const temp_init_type& temp_init,
                  const n_thermostat_type& n_thermostat,
                  const needs_init_type& needs_init,
                  const num_dim_of_sim_type& num_dim_of_sim,
                  const gradual_type& gradual)
: ::xml_schema::type (),
  temp_init_ (temp_init, this),
  n_thermostat_ (n_thermostat, this),
  needs_init_ (needs_init, this),
  num_dim_of_sim_ (num_dim_of_sim, this),
  temp_target_ (this),
  gradual_ (gradual, this),
  temp_delta_ (this)
{
}

extra_thermostat::
extra_thermostat (const extra_thermostat& x,
                  ::xml_schema::flags f,
                  ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  temp_init_ (x.temp_init_, f, this),
  n_thermostat_ (x.n_thermostat_, f, this),
  needs_init_ (x.needs_init_, f, this),
  num_dim_of_sim_ (x.num_dim_of_sim_, f, this),
  temp_target_ (x.temp_target_, f, this),
  gradual_ (x.gradual_, f, this),
  temp_delta_ (x.temp_delta_, f, this)
{
}

extra_thermostat::
extra_thermostat (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f,
                  ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  temp_init_ (this),
  n_thermostat_ (this),
  needs_init_ (this),
  num_dim_of_sim_ (this),
  temp_target_ (this),
  gradual_ (this),
  temp_delta_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void extra_thermostat::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // temp_init
    //
    if (n.name () == "temp_init" && n.namespace_ ().empty ())
    {
      if (!temp_init_.present ())
      {
        this->temp_init_.set (temp_init_traits::create (i, f, this));
        continue;
      }
    }

    // n_thermostat
    //
    if (n.name () == "n_thermostat" && n.namespace_ ().empty ())
    {
      if (!n_thermostat_.present ())
      {
        this->n_thermostat_.set (n_thermostat_traits::create (i, f, this));
        continue;
      }
    }

    // needs_init
    //
    if (n.name () == "needs_init" && n.namespace_ ().empty ())
    {
      if (!needs_init_.present ())
      {
        this->needs_init_.set (needs_init_traits::create (i, f, this));
        continue;
      }
    }

    // num_dim_of_sim
    //
    if (n.name () == "num_dim_of_sim" && n.namespace_ ().empty ())
    {
      if (!num_dim_of_sim_.present ())
      {
        this->num_dim_of_sim_.set (num_dim_of_sim_traits::create (i, f, this));
        continue;
      }
    }

    // temp_target
    //
    if (n.name () == "temp_target" && n.namespace_ ().empty ())
    {
      if (!this->temp_target_)
      {
        this->temp_target_.set (temp_target_traits::create (i, f, this));
        continue;
      }
    }

    // gradual
    //
    if (n.name () == "gradual" && n.namespace_ ().empty ())
    {
      if (!gradual_.present ())
      {
        this->gradual_.set (gradual_traits::create (i, f, this));
        continue;
      }
    }

    // temp_delta
    //
    if (n.name () == "temp_delta" && n.namespace_ ().empty ())
    {
      if (!this->temp_delta_)
      {
        this->temp_delta_.set (temp_delta_traits::create (i, f, this));
        continue;
      }
    }

    break;
  }

  if (!temp_init_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "temp_init",
      "");
  }

  if (!n_thermostat_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "n_thermostat",
      "");
  }

  if (!needs_init_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "needs_init",
      "");
  }

  if (!num_dim_of_sim_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "num_dim_of_sim",
      "");
  }

  if (!gradual_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "gradual",
      "");
  }
}

extra_thermostat* extra_thermostat::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class extra_thermostat (*this, f, c);
}

extra_thermostat& extra_thermostat::
operator= (const extra_thermostat& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->temp_init_ = x.temp_init_;
    this->n_thermostat_ = x.n_thermostat_;
    this->needs_init_ = x.needs_init_;
    this->num_dim_of_sim_ = x.num_dim_of_sim_;
    this->temp_target_ = x.temp_target_;
    this->gradual_ = x.gradual_;
    this->temp_delta_ = x.temp_delta_;
  }

  return *this;
}

extra_thermostat::
~extra_thermostat ()
{
}

// extra_linked_cell
//

extra_linked_cell::
extra_linked_cell (const center_x_type& center_x,
                   const center_y_type& center_y,
                   const center_z_type& center_z,
                   const domain_x_type& domain_x,
                   const domain_y_type& domain_y,
                   const domain_z_type& domain_z,
                   const cutoffradius_type& cutoffradius,
                   const left_bound_cond_type& left_bound_cond,
                   const right_bound_cond_type& right_bound_cond,
                   const down_bound_cond_type& down_bound_cond,
                   const up_bound_cond_type& up_bound_cond,
                   const front_bound_cond_type& front_bound_cond,
                   const back_bound_cond_type& back_bound_cond)
: ::xml_schema::type (),
  center_x_ (center_x, this),
  center_y_ (center_y, this),
  center_z_ (center_z, this),
  domain_x_ (domain_x, this),
  domain_y_ (domain_y, this),
  domain_z_ (domain_z, this),
  cutoffradius_ (cutoffradius, this),
  left_bound_cond_ (left_bound_cond, this),
  right_bound_cond_ (right_bound_cond, this),
  down_bound_cond_ (down_bound_cond, this),
  up_bound_cond_ (up_bound_cond, this),
  front_bound_cond_ (front_bound_cond, this),
  back_bound_cond_ (back_bound_cond, this)
{
}

extra_linked_cell::
extra_linked_cell (const extra_linked_cell& x,
                   ::xml_schema::flags f,
                   ::xml_schema::container* c)
: ::xml_schema::type (x, f, c),
  center_x_ (x.center_x_, f, this),
  center_y_ (x.center_y_, f, this),
  center_z_ (x.center_z_, f, this),
  domain_x_ (x.domain_x_, f, this),
  domain_y_ (x.domain_y_, f, this),
  domain_z_ (x.domain_z_, f, this),
  cutoffradius_ (x.cutoffradius_, f, this),
  left_bound_cond_ (x.left_bound_cond_, f, this),
  right_bound_cond_ (x.right_bound_cond_, f, this),
  down_bound_cond_ (x.down_bound_cond_, f, this),
  up_bound_cond_ (x.up_bound_cond_, f, this),
  front_bound_cond_ (x.front_bound_cond_, f, this),
  back_bound_cond_ (x.back_bound_cond_, f, this)
{
}

extra_linked_cell::
extra_linked_cell (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f,
                   ::xml_schema::container* c)
: ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
  center_x_ (this),
  center_y_ (this),
  center_z_ (this),
  domain_x_ (this),
  domain_y_ (this),
  domain_z_ (this),
  cutoffradius_ (this),
  left_bound_cond_ (this),
  right_bound_cond_ (this),
  down_bound_cond_ (this),
  up_bound_cond_ (this),
  front_bound_cond_ (this),
  back_bound_cond_ (this)
{
  if ((f & ::xml_schema::flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void extra_linked_cell::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // center_x
    //
    if (n.name () == "center_x" && n.namespace_ ().empty ())
    {
      if (!center_x_.present ())
      {
        this->center_x_.set (center_x_traits::create (i, f, this));
        continue;
      }
    }

    // center_y
    //
    if (n.name () == "center_y" && n.namespace_ ().empty ())
    {
      if (!center_y_.present ())
      {
        this->center_y_.set (center_y_traits::create (i, f, this));
        continue;
      }
    }

    // center_z
    //
    if (n.name () == "center_z" && n.namespace_ ().empty ())
    {
      if (!center_z_.present ())
      {
        this->center_z_.set (center_z_traits::create (i, f, this));
        continue;
      }
    }

    // domain_x
    //
    if (n.name () == "domain_x" && n.namespace_ ().empty ())
    {
      if (!domain_x_.present ())
      {
        this->domain_x_.set (domain_x_traits::create (i, f, this));
        continue;
      }
    }

    // domain_y
    //
    if (n.name () == "domain_y" && n.namespace_ ().empty ())
    {
      if (!domain_y_.present ())
      {
        this->domain_y_.set (domain_y_traits::create (i, f, this));
        continue;
      }
    }

    // domain_z
    //
    if (n.name () == "domain_z" && n.namespace_ ().empty ())
    {
      if (!domain_z_.present ())
      {
        this->domain_z_.set (domain_z_traits::create (i, f, this));
        continue;
      }
    }

    // cutoffradius
    //
    if (n.name () == "cutoffradius" && n.namespace_ ().empty ())
    {
      if (!cutoffradius_.present ())
      {
        this->cutoffradius_.set (cutoffradius_traits::create (i, f, this));
        continue;
      }
    }

    // left_bound_cond
    //
    if (n.name () == "left_bound_cond" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< left_bound_cond_type > r (
        left_bound_cond_traits::create (i, f, this));

      if (!left_bound_cond_.present ())
      {
        this->left_bound_cond_.set (::std::move (r));
        continue;
      }
    }

    // right_bound_cond
    //
    if (n.name () == "right_bound_cond" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< right_bound_cond_type > r (
        right_bound_cond_traits::create (i, f, this));

      if (!right_bound_cond_.present ())
      {
        this->right_bound_cond_.set (::std::move (r));
        continue;
      }
    }

    // down_bound_cond
    //
    if (n.name () == "down_bound_cond" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< down_bound_cond_type > r (
        down_bound_cond_traits::create (i, f, this));

      if (!down_bound_cond_.present ())
      {
        this->down_bound_cond_.set (::std::move (r));
        continue;
      }
    }

    // up_bound_cond
    //
    if (n.name () == "up_bound_cond" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< up_bound_cond_type > r (
        up_bound_cond_traits::create (i, f, this));

      if (!up_bound_cond_.present ())
      {
        this->up_bound_cond_.set (::std::move (r));
        continue;
      }
    }

    // front_bound_cond
    //
    if (n.name () == "front_bound_cond" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< front_bound_cond_type > r (
        front_bound_cond_traits::create (i, f, this));

      if (!front_bound_cond_.present ())
      {
        this->front_bound_cond_.set (::std::move (r));
        continue;
      }
    }

    // back_bound_cond
    //
    if (n.name () == "back_bound_cond" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< back_bound_cond_type > r (
        back_bound_cond_traits::create (i, f, this));

      if (!back_bound_cond_.present ())
      {
        this->back_bound_cond_.set (::std::move (r));
        continue;
      }
    }

    break;
  }

  if (!center_x_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "center_x",
      "");
  }

  if (!center_y_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "center_y",
      "");
  }

  if (!center_z_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "center_z",
      "");
  }

  if (!domain_x_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "domain_x",
      "");
  }

  if (!domain_y_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "domain_y",
      "");
  }

  if (!domain_z_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "domain_z",
      "");
  }

  if (!cutoffradius_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "cutoffradius",
      "");
  }

  if (!left_bound_cond_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "left_bound_cond",
      "");
  }

  if (!right_bound_cond_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "right_bound_cond",
      "");
  }

  if (!down_bound_cond_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "down_bound_cond",
      "");
  }

  if (!up_bound_cond_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "up_bound_cond",
      "");
  }

  if (!front_bound_cond_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "front_bound_cond",
      "");
  }

  if (!back_bound_cond_.present ())
  {
    throw ::xsd::cxx::tree::expected_element< char > (
      "back_bound_cond",
      "");
  }
}

extra_linked_cell* extra_linked_cell::
_clone (::xml_schema::flags f,
        ::xml_schema::container* c) const
{
  return new class extra_linked_cell (*this, f, c);
}

extra_linked_cell& extra_linked_cell::
operator= (const extra_linked_cell& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::type& > (*this) = x;
    this->center_x_ = x.center_x_;
    this->center_y_ = x.center_y_;
    this->center_z_ = x.center_z_;
    this->domain_x_ = x.domain_x_;
    this->domain_y_ = x.domain_y_;
    this->domain_z_ = x.domain_z_;
    this->cutoffradius_ = x.cutoffradius_;
    this->left_bound_cond_ = x.left_bound_cond_;
    this->right_bound_cond_ = x.right_bound_cond_;
    this->down_bound_cond_ = x.down_bound_cond_;
    this->up_bound_cond_ = x.up_bound_cond_;
    this->front_bound_cond_ = x.front_bound_cond_;
    this->back_bound_cond_ = x.back_bound_cond_;
  }

  return *this;
}

extra_linked_cell::
~extra_linked_cell ()
{
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

::std::unique_ptr< ::eingabe_t >
eingabe (const ::std::string& u,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::eingabe_t > (
    ::eingabe (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::eingabe_t >
eingabe (const ::std::string& u,
         ::xml_schema::error_handler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::eingabe_t > (
    ::eingabe (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::eingabe_t >
eingabe (const ::std::string& u,
         ::xercesc::DOMErrorHandler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::eingabe_t > (
    ::eingabe (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::eingabe_t >
eingabe (::std::istream& is,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::eingabe (isrc, f, p);
}

::std::unique_ptr< ::eingabe_t >
eingabe (::std::istream& is,
         ::xml_schema::error_handler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::eingabe (isrc, h, f, p);
}

::std::unique_ptr< ::eingabe_t >
eingabe (::std::istream& is,
         ::xercesc::DOMErrorHandler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::eingabe (isrc, h, f, p);
}

::std::unique_ptr< ::eingabe_t >
eingabe (::std::istream& is,
         const ::std::string& sid,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::eingabe (isrc, f, p);
}

::std::unique_ptr< ::eingabe_t >
eingabe (::std::istream& is,
         const ::std::string& sid,
         ::xml_schema::error_handler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::flags::dont_initialize) == 0,
    (f & ::xml_schema::flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::eingabe (isrc, h, f, p);
}

::std::unique_ptr< ::eingabe_t >
eingabe (::std::istream& is,
         const ::std::string& sid,
         ::xercesc::DOMErrorHandler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::eingabe (isrc, h, f, p);
}

::std::unique_ptr< ::eingabe_t >
eingabe (::xercesc::InputSource& i,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::eingabe_t > (
    ::eingabe (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::eingabe_t >
eingabe (::xercesc::InputSource& i,
         ::xml_schema::error_handler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::eingabe_t > (
    ::eingabe (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::eingabe_t >
eingabe (::xercesc::InputSource& i,
         ::xercesc::DOMErrorHandler& h,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::eingabe_t > (
    ::eingabe (
      std::move (d), f | ::xml_schema::flags::own_dom, p));
}

::std::unique_ptr< ::eingabe_t >
eingabe (const ::xercesc::DOMDocument& doc,
         ::xml_schema::flags f,
         const ::xml_schema::properties& p)
{
  if (f & ::xml_schema::flags::keep_dom)
  {
    ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
      static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

    return ::std::unique_ptr< ::eingabe_t > (
      ::eingabe (
        std::move (d), f | ::xml_schema::flags::own_dom, p));
  }

  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (n.name () == "eingabe" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::eingabe_t > r (
      ::xsd::cxx::tree::traits< ::eingabe_t, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "eingabe",
    "");
}

::std::unique_ptr< ::eingabe_t >
eingabe (::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d,
         ::xml_schema::flags f,
         const ::xml_schema::properties&)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > c (
    ((f & ::xml_schema::flags::keep_dom) &&
     !(f & ::xml_schema::flags::own_dom))
    ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
    : 0);

  ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (f & ::xml_schema::flags::keep_dom)
    doc.setUserData (::xml_schema::dom::tree_node_key,
                     (c.get () ? &c : &d),
                     0);

  if (n.name () == "eingabe" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::eingabe_t > r (
      ::xsd::cxx::tree::traits< ::eingabe_t, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "eingabe",
    "");
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

